CMSIS DSP Software Library: Complex Magnitude

Functions

# Complex Magnitude
[Complex Math Functions]

## Functions
void | arm_cmplx_mag_f32 (float32_t *pSrc, float32_t *pDst, uint32_t numSamples)
void | arm_cmplx_mag_q31 (q31_t *pSrc, q31_t *pDst, uint32_t numSamples)
void | arm_cmplx_mag_q15 (q15_t *pSrc, q15_t *pDst, uint32_t numSamples)

## Detailed Description

Computes the magnitude of the elements of a complex data vector.

The `pSrc` points to the source data and `pDst` points to the where the result should be written. `numSamples` specifies the number of complex samples in the input array and the data is stored in an interleaved fashion (real, imag, real, imag, ...). The input array has a total of `2*numSamples` values; the output array has a total of `numSamples` values. The underlying algorithm is used:

     for(n=0; n<numSamples; n++) {
         pDst[n] = sqrt(pSrc[(2*n)+0]^2 + pSrc[(2*n)+1]^2);
     }

There are separate functions for floating-point, Q15, and Q31 data types.

## Function Documentation

void arm_cmplx_mag_f32 | ( | float32_t * | pSrc,
|  | float32_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Floating-point complex magnitude.

Parameters:

  [in] | *pSrc | points to complex input buffer
  [out] | *pDst | points to real output buffer
  [in] | numSamples | number of complex samples in the input vector

Returns:
  none.

Examples:
  arm_fft_bin_example_f32.c.

Definition at line 73 of file arm_cmplx_mag_f32.c.

void arm_cmplx_mag_q31 | ( | q31_t * | pSrc,
|  | q31_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Q31 complex magnitude.

Parameters:

  *pSrc | points to the complex input vector
  *pDst | points to the real output vector
  numSamples | number of complex samples in the input vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function implements 1.31 by 1.31 multiplications and finally output is converted into 2.30 format. Input down scaling is not required.

Definition at line 54 of file arm_cmplx_mag_q31.c.

void arm_cmplx_mag_q15 | ( | q15_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Q15 complex magnitude.

Parameters:

  *pSrc | points to the complex input vector
  *pDst | points to the real output vector
  numSamples | number of complex samples in the input vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function implements 1.15 by 1.15 multiplications and finally output is converted into 2.14 format.

Definition at line 54 of file arm_cmplx_mag_q15.c.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines